#include <stdio.h>
#include <dos.h>
#include "pcxview.h"
#include "mouselib.h"

#define putdot(x,y,c) *((unsigned char far *)0xa0000000 + (unsigned)((x) + (y)*320))=c
#define getdot(x,y) *((unsigned char far *)0xa0000000 + (unsigned)((x) + (y)*320))

int zx1, zy1, zx2, zy2, zoom;
int x, y, lx, ly, ox, oy, col;
int curx, cury;
char buf[20][20];
char far *scr;

void convert2bw()
{
  char r, g, b;
  int x, y;

  for (y=0; y<200; y++)
	for (x=0; x<320; x++) {
	  getrgb(getdot(x,y), &r, &g, &b);
	  r=((r+g+b)/3);
	  putdot(x,y,r);
	}

  for (x=0; x<64; x++) setrgb(x, x, x, x);
}

void drawbox(int top, int left, int bottom, int right)
{
  int t;
  static int var=0;
  static int inc=1;

  if (var < 0 || var > 20)
	inc=-inc;

  var=var+inc;

	for (t=top; t<=bottom; t++) {
		putdot(left, t, getdot(left, t)+var);
		putdot(right, t, getdot(right, t)+var);
	}

	for (t=left+1; t<right; t++) {
		putdot(t, top, getdot(t, top)+var);
		putdot(t, bottom, getdot(t, bottom)+var);
	}

	delay(10);

	for (t=top; t<=bottom; t++) {
		putdot(left, t, getdot(left, t)-var);
		putdot(right, t, getdot(right, t)-var);
	}

	for (t=left+1; t<right; t++) {
		putdot(t, top, getdot(t, top)-var);
		putdot(t, bottom, getdot(t, bottom)-var);
	}
}

void redraw()
{
	movedata(FP_SEG(scr), FP_OFF(scr),
			(unsigned)0xA000, (unsigned)0, 64000);
}

void zzoom()
{
int x,y,lx,ly;
int col;
int height, width;

	height=(zy2-zy1);
	width=(zx2-zx1);

  for (y=0; y<height; y++)
	for (x=0; x<width; x++)
	  for (ly=0; ly<zoom; ly++)
		for (lx=0; lx<zoom; lx++)
		{
			col=buf[y][x];
			putdot(ox+lx+(x-zx1)*zoom, oy+ly+(y-zy1)*zoom, col);
		}

	do mouseprocess();
	while (mlb_pres);

	redraw();
}

void rzoom()
{
int x,y,lx,ly;
int col;
int height, width;
float xp, yp;

	height=(zy2-zy1);
	width=(zx2-zx1);

	for (y=0; y<height-1; y++)
		for (x=0; x<width-1; x++)
			for (ly=0; ly<zoom; ly++)
				for (lx=0; lx<zoom; lx++)
				{
					xp=(float)(lx+1)/zoom;
					yp=(float)(ly+1)/zoom;

					col=(int)( (1-yp)*((1-xp)*buf[y][x] +
						xp*buf[y][x+1]) +
						yp*((1-xp)*buf[y+1][x] + xp*buf[y+1][x+1]) );

					putdot(ox+lx+(x-zx1)*zoom, oy+ly+(y-zy1)*zoom, col);
				}

	do mouseprocess();
	while (mrb_pres);

	redraw();
}

void savearea()
{
int height, width;

	height=(zy2-zy1);
	width=(zx2-zx1);

	for (y=0; y<height; y++)
		for (x=0; x<width; x++)
			buf[y][x]=getdot(x+zx1+curx ,y+zy1+cury);
}

void main(int argc, char *argv[])
{
  char butnum;

  if (argc < 2) exit(1);

  if (!MouseState(&butnum)) {
	printf("Mouse is not installed!\n");
	exit(1);
  }

  scr=(char far *)farmalloc(64000);
  if (scr==NULL)
  {
	printf("Not enough memory!\n");
	exit(1);
  }

  asm mov ax, 13h
  asm int 10h

  zx1=0; zy1=0;
  zx2=zx1+20;  zy2=zy1+20;
  ox=0;
  oy=0;
  zoom=9;


  savergb();

  video(1);
  viewpcx(argv[1]);
  convert2bw();
  video(0);

	movedata((unsigned)0xA000, (unsigned)0,
			 FP_SEG(scr), FP_OFF(scr), 64000);

  while (!kbhit()) {
	mouseprocess();

	GetCoordinate(&curx, &cury);  /* returns graphical coordinate */
	curx/=2;
	if (curx < 2) curx=2;
	if (curx > 300-3) curx=300-3;
	if (cury < 2) cury=2;
	if (cury > 180-3) cury=180-3;

	drawbox(zy1-2+cury, zx1-2+curx, zy2+2+cury, zx2+2+curx);

	if (mlb_pres)
	{
		savearea();
		zzoom();
	}

	if (mrb_pres)
	{
		savearea();
		rzoom();
	}
  }


  restorergb();

  asm mov ax, 3h
  asm int 10h

  printf("Linear Interpolation Zoom, Coder: Jinhong Kim (5th Member)\n");
}


